commit 099857318ca92210e34cfb8975c5c58c00bf1587
Author: Tobias Burnus <tobias@codesourcery.com>
Date:   Fri Nov 6 08:26:51 2020 +0100

    Fortran: Fix type-decl for PDT / wrong-code pdt_14.f03 issue [PR97652]
    
    Parameterized derived types are handled in a special way and start with 'Pdt'.
    If the 'P' is not uppercase, gfc_get_derived_type (which calls
    gfc_get_module_backend_decl) does not find the existing declaration and
    builds a new type. The middle end then sees those types as being different
    and nonalising, creating an endless loop for pdt_14.f03.
    
    gcc/fortran/ChangeLog:
    
            PR fortran/97652
            * module.c (mio_symbol): Fix symbol name for pdt_type.
    
    (cherry picked from commit c283a711c850efaab4fe3bca5ef7200eb854bba1)

diff --git a/gcc/fortran/module.c b/gcc/fortran/module.c
index eccf92bf658..9a5b1cb7625 100644
--- a/gcc/fortran/module.c
+++ b/gcc/fortran/module.c
@@ -4411,6 +4411,9 @@ mio_symbol (gfc_symbol *sym)
 
   mio_symbol_attribute (&sym->attr);
 
+  if (sym->attr.pdt_type)
+    sym->name = gfc_dt_upper_string (sym->name);
+
   /* Note that components are always saved, even if they are supposed
      to be private.  Component access is checked during searching.  */
   mio_component_list (&sym->components, sym->attr.vtype);

